/**
   This class defines "closures".

   A closure is just two references,
      1) a reference to a lambda expression,
      2) a reference to an environment.
   The environment object is where the interpreter
   will find all the bindings for non-local references
   made in the lambda expression. In other words, if
   the lambda expression is "open" (it makes non-local
   references), then the environmnt object "closes"
   the lambda expression. The combination of a lambda
   expression with a environment that closes it is
   called a "closure".
*/

public class IPEP
{
   public Tree ip;        // the ip, the "instruction pointer"
   public Environment ep; // the ep, the "environment pointer"

   /**
      Construct a IPEP object
   */
   public IPEP(Tree tree, Environment env)
   {
      this.ip = tree;
      this.ep = env;
   }
}//IPEP
