#lang racket

; Remove "prog".
; Replace "var" and "fun" with Racket's "define"
; but "define" is not allowed to be nested
; because it is a statement, not an expression.

;(define r ((define g (lambda (x) (* x x))) 5))


(define g (lambda (h) (h 5)))
(g (lambda (x) (* x x))) ; pass an anonymous lambda as a parameter


; apply an anonymous function (with a function parameter) to an anonymous function
((lambda (h) (h 7)) (lambda (x) (+ x x x)))


; anonymous functions as return values
(define h (lambda (b) (if b
                        (lambda (x) (* x x))      ; anonymous lambda
                        (lambda (x) (* x x x))))) ; anonymous lambda
(define r1 ((h true) 5)) 
(print r1)                ; prints 25
(define r2 ((h false) 5)) 
(print r2)                ; prints 125


; another anonymous function as a return value.
(define x -100)
(define f (lambda (x) (lambda (y) (+ y x))))
((f 5) 100)


; Demonstrate a nested anonymous function parameter.
(define w 300 )              ; w is a global variable
(define f1 (lambda (x) (f2 (lambda (y) (+ x y w)))))
(define f2 (lambda (z)       ; z is a function parameter
             (define w 200)  ; w is a local variable
             (z (/ w 10))))  ; call the function parameter
(f1 1)
