#lang racket

; Remove "prog".
; Replace "var" and "fun" with Racket's "define".
; Replace "set" with Racket's "set!".


(define f1 (lambda (x) 100))  ; global f1
(define f2 (lambda (y)
                (define f1 (lambda (w) 10))  ; nested f1
                (f3 0)))
(define f3 (lambda (z) (f1 0)))   ; which f1 is called?
(f2 0)


; Demonstrate a function parameter.
;(prog
(define w 300)
(define g1 (lambda (x)
              (define g2 (lambda (y) (+ (+ x y) w))) ; nested function
              (g3 g2)))      ; nested function passed as a parameter
(define g3 (lambda (z)       ; z is a function parameter
              (define w 400)
              (z 20))) ; call the function parameter
(g1 1)


; Show that a function can be passed as a parameter.
;(prog
(define n 2)
(define f (lambda (x) (* n x )))
(define g (lambda (h) (h 5)))
(set! n 10)
(g f)      ; pass f as an argument to g


; Show that a function can be the return value.
;(prog
(define x -100)
(define h (lambda (x)
             (define g (lambda (y) (+ y x)))
             g))  ; h returns g
((h 5) 100)
